#include "DeerRender/UIEngine/UIEngineFunctions.h"
#include "DeerRender/UIEngine/UIEngine.h"
#include "DeerRender/UIEngine/ErrorHandle.h"

namespace Deer {
    void UIEngine::registerUIEngineFunctions() {
        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void coloredText(float, float, float, const string& in)",
            asFUNCTION(
                Deer::UIEngine::coloredText
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void text(const string& in)",
            asFUNCTION(
                text
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "bool isMouseClicked(int)",
            asFUNCTION(
                isMouseClicked
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "bool isMouseDoubleClicked(int)",
            asFUNCTION(
                isMouseDoubleClicked
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void setupAutomaticColumns(int)",
            asFUNCTION(
                setupAutomaticColumns
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void endColumns()",
            asFUNCTION(
                endColumns
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void nextColumn()",
            asFUNCTION(
                nextColumn
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "void print(const string& in)",
            asFUNCTION (
                Deer::UIEngine::print
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "int getMeshCount(const string& in)",
            asFUNCTION(
                Deer::UIEngine::getMeshCount
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "string getMeshPath(const string& in, int)",
            asFUNCTION(
                Deer::UIEngine::getMeshPath
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "string getMeshName(const string& in, int)",
            asFUNCTION(
                Deer::UIEngine::getMeshName
            ),
            asCALL_CDECL
        ));


        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "int getMeshDirCount(const string& in)",
            asFUNCTION(
                Deer::UIEngine::getMeshDirCount
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "string getMeshDirPath(const string& in, int)",
            asFUNCTION(
                Deer::UIEngine::getMeshDirPath
            ),
            asCALL_CDECL
        ));

        AS_CHECK(scriptEngine->RegisterGlobalFunction(
            "string getMeshDirName(const string& in, int)",
            asFUNCTION(
                Deer::UIEngine::getMeshDirName
            ),
            asCALL_CDECL
        ));
    }
}