#pragma once
#include <string>

class asSMessageInfo;
namespace Deer {
    namespace UIEngine {
        // TODO: Detect if it has menu bar
        // TODO: Make icon an enum
        
        // --- Mesh Data Store ---

        // Returns the count of meshes in the dir relative to the mesh root dir
        int getMeshCount(std::string& dir);
        // Returns the path to the mesh with id i
        std::string getMeshPath(std::string& dir, int i);
        // Returns the name of the mesh with id i
        std::string getMeshName(std::string& dir, int i);

        // Returns the count of sub dirs in the dir relative to the mesh root dir
        int getMeshDirCount(std::string& dir);
        // Returns the path to the subDir in the dir relative to the mesh root dir
        std::string getMeshDirPath(std::string& dir, int i);
        // Returns the name of the subDir in the dir relative to the mesh root dir
        std::string getMeshDirName(std::string& dir, int i);

        // --- RENDERING ---

        // TEXT
        // Renders a text with the defined rgb values from range [0.0, 1.0]
        void coloredText(float r, float g, float b, std::string& msg);
        // Renders a text
        void text(std::string& msg);

        // Images
        // TODO: Implement
        void drawIcon(std::string& iconId, int size);

        // Returns if the specified mouse button is clicked
        bool isMouseClicked(int mouse);
        // Returns if the specified mouse button is double clicked
        bool isMouseDoubleClicked(int mouse);

        // Set up the colums to fit the pixelSize elements
        void setupAutomaticColumns(int pixelSize);
        // Iterates to the next column
        void nextColumn();
        // Ends the columns made with setupColumns
        void endColumns();

        void errorCallback(const asSMessageInfo *msg, void *param);
        // Prints in console a mesage
        void print(std::string& msg);
    }
}